var PLUGIN_ID = "Recorder_Plugin";
var PLUGIN_CONFIG;
var saveDone = true;

var URL_IN = "../../utils/redirector.php?dest=componentlist";
var URL_CONFIG = "../../utils/redirector.php?dest=getinfo";
var URL_OUT = "../../utils/redirector.php?dest=pluginConfig";
var URL_DATA = "../../utils/redirector.php?dest=getdata";

  $(function() {
    $( "#viewmodetoggle" ).buttonset();
  });

$(document).ready(function() {
	

	


	var vars = [], hash;
	var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
	console.log(hashes);
	var remoteIp = "";
	var port = "";
	if (hashes.length == 2) {
		for (var i = 0; i < hashes.length; i++) {
			hash = hashes[i].split('=');
			vars.push(hash[0]);
			vars[hash[0]] = hash[1];
		}
		remoteIp = vars["remoteIp"].replace("#", "");
		port = vars["port"].replace("#", "");
	}

		$("#startdate").datepicker({dateFormat: "dd-mm-yy"});
		$("#stopdate").datepicker({dateFormat: "dd-mm-yy"});
            	$("#Export").on("click", function(e) {
			var link='http://'+remoteIp+':7070?id=Recorder_Base&dest=export&params='+$("#startdate").val()+'|'+$("#stopdate").val()+'|'+$("#componentsToExport").val();
			console.log(link);
    		window.open(link);
    	});

console.log(vars);
	if (remoteIp == "")
		remoteIp = "localhost";

	if (port == "")
		port = "7070";

	var reqAddr = "&remoteIp=" + remoteIp + "&port=" + port;
	URL_IN = URL_IN + reqAddr;
	URL_CONFIG = URL_CONFIG + reqAddr;
	URL_OUT = URL_OUT + reqAddr;
	URL_DATA = URL_DATA + reqAddr;

	//get plugin config
	$.ajax({
		url : URL_CONFIG,
		cache : false,
		data : {
			id : 'Recorder_Base'
		},
		dataType : "json",

		error : function(qXHR, textStatus, errorThrown) {
			console.debug(qXHR);
			console.debug(textStatus);
			console.debug(errorThrown);
		},

		success : function(json) {
			PLUGIN_CONFIG=json;
			if (json.pluginStatus == 'enabled') {
				$('#onOffToggle').prop('checked', false);
				$('#onOffToggle').button("refresh");
				$("#onOffToggle").button("option", "label", "On");
			} else {
				$('#onOffToggle').prop('checked', true);
				$('#onOffToggle').button("refresh");
				$("#onOffToggle").button("option", "label", "Off");
			}
			$("#chartNumber").val(PLUGIN_CONFIG.chartNumber);
			
			//get configured components thresholds
			if (PLUGIN_CONFIG.componentThresholds != null && PLUGIN_CONFIG.componentThresholds.length > 0) {
				for (var i = 0; i < PLUGIN_CONFIG.componentThresholds.length; ++i) {

					var $li = $("<li></li>");
					var $category = $("<span></span>");
					var $description = $("<span></span>");
					var $input = $("<input type='text' value='"+PLUGIN_CONFIG.componentThresholds[i].threshold+"' onkeypress='bigh.onlyPosFloat();'></input>");
					var $remove = $("<span>&nbsp;</span>");


					$category.text(PLUGIN_CONFIG.componentThresholds[i].category);
					$category.addClass("category");
					$description.text(PLUGIN_CONFIG.componentThresholds[i].name);
					$description.addClass("name");
					$input.addClass("inputThreshold");
					$remove.addClass("removeThreshold").addClass("ui-icon").addClass("ui-icon-circle-close");

					$li.attr("title", PLUGIN_CONFIG.componentThresholds[i].name);
					$li.attr("component-id", PLUGIN_CONFIG.componentThresholds[i].uid);

					$li.append($category).append($description).append($input).append($remove);
					$("#thresholds").append($li);
									
				}
			}
			
		},
	});

	//get components list
	$.ajax({
		url : URL_IN,
		cache : false,
		dataType : "json",

		error : function(qXHR, textStatus, errorThrown) {
			console.debug(qXHR);
			console.debug(textStatus);
			console.debug(errorThrown);
		},

		success : function(json) {

			//look for installed components
			for (var i = 0; i < json.response.length; ++i) {
				var component = json.response[i];
				if(component.name.toLowerCase().indexOf('_base') > -1)
					continue;
				//Get current component
				if (component.subComponent != null && component.subComponent !== undefined && component.subComponent != "") {
					var subCompArray = component.subComponent;
										
					subCompArray.sort(function(a, b) {
						var nameA = a.name.toLowerCase();
						var nameB = b.name.toLowerCase();
						if (nameA < nameB)//sort string ascending
							return -1;
						if (nameA > nameB)
							return 1;
						return 0;//default return value (no sorting)
					});
					
					var $defaultOption = $("<option></option>");
					$defaultOption.val("");
					$defaultOption.text("Choose a component...");
					$('#select-components').append($defaultOption);
					
			
				
					
					for (var j = 0; j < subCompArray.length; ++j) {
						var component = subCompArray[j];
						
						//if (component.category.toLowerCase() == "evethermo" || component.category.toLowerCase() == "eveswitch" || component.category.toLowerCase() == "eveslider" || component.category.toLowerCase() == "eveinfo" || component.category.toLowerCase() == "evebyte") 
						{
						 	
						 if (component.tags.indexOf( "ENERGY COUNTER")>-1 || component.tags.indexOf( "VIEW 1")>-1 || component.tags.indexOf( "SHOW IN RECORDER WEBPAGE")>-1)
						 {
						 
						 	console.log(component.tags);
							var $option = $("<option></option>");
							$option.val(component.id);
							$option.text(component.name);
							$option.data("myReference", component);
							$("#componentsToExport").append($option);
							
							}		
						}
					}
					$('#componentsToExport').change(function() {
            console.log($(this).val());
        }).multipleSelect({
filter: true,
            width: '100%'
        });

				}
			}
		},
	});

	$.ajax({
        url: "config/info.txt",
        //force to handle it as text
        dataType: "text",
        success: function(data) {
            var json = $.parseJSON(data);
            var version = 'v'+json.version;
            $('#version').text(version);
        },
        error : function(qXHR, textStatus, errorThrown) {
			console.debug(qXHR);
			console.debug(textStatus);
			console.debug(errorThrown);
		}
    });

	$("#onOffToggle").button();
	$("#onOffToggle").click(function() {
		var label = $("#onOffToggle").button("option", "label");
		var nextLabel = '';
		var pluginStatus = null;
		if (label == 'On') {
			nextLabel = 'Off';
			pluginStatus = 'disabled';
			PLUGIN_CONFIG.pluginStatus='disabled';
		} else {
			nextLabel = 'On';
			pluginStatus = 'enabled';
			PLUGIN_CONFIG.pluginStatus='enabled';
		}

		$.ajax({
			url : URL_OUT,
			type : "post",
			data : {
				config : JSON.stringify(PLUGIN_CONFIG),
				comp : 'Recorder_Base'
			},
			dataType : "text",
			success : function(json) {
				$("#onOffToggle").button("option", "label", nextLabel);

			},
			error : function(json) {
				$("#onOffToggle").button("option", "label", "Err");
			}
		});
	});
	
	
	//import config file
//	document.getElementById('file').addEventListener('change', handleFileSelect, false);
	function handleFileSelect(evt) {
		$("#import-status").hide();
		var file = evt.target.files[0];

	/*	if (file.name.lastIndexOf(".") > 0) {
            var fileExtension = file.name.substring(file.name.lastIndexOf(".") + 1, file.name.length);
            if(fileExtension.toLowerCase != 'cfg') {
            	alert();
            }
       } else {
       		alert();
       }*/
		var reader = new FileReader();
		// Closure to capture the file information.
		reader.onload = (function(theFile) {
			return function(e) {			
				try {
					var fileContentToJson = JSON.parse(e.target.result);
					//get components list
					$.ajax({
						url : URL_IN,
						cache : false,
						dataType : "json",
				
						error : function(qXHR, textStatus, errorThrown) {
							console.debug(qXHR);
							console.debug(textStatus);
							console.debug(errorThrown);
						},
				
						success : function(json) {
				
							//look for installed components
							for (var i = 0; i < json.response.length; ++i) {
								var component = json.response[i];
								if(component.name.toLowerCase().indexOf('_base') > -1)
									continue;
								//Get current component
								if (component.subComponent != null && component.subComponent !== undefined && component.subComponent != "") {
									var subCompArray = component.subComponent;									
									for (var j = 0; j < subCompArray.length; ++j) {
										var component = subCompArray[j];
										
										for (var z = 0; z < fileContentToJson.componentThresholds.length; ++z) {
											if(fileContentToJson.componentThresholds[z].name.toLowerCase().trim() == component.name.toLowerCase().trim()) { //first check if component exist on eve (name check)
												if(PLUGIN_CONFIG.componentThresholds.length == 0) {
													fileContentToJson.componentThresholds[z].uid = component.id;
													PLUGIN_CONFIG.componentThresholds.push(fileContentToJson.componentThresholds[z]);
												} else {
													var found = false;
													for (var q = 0; q < PLUGIN_CONFIG.componentThresholds.length; ++q) {
														if(PLUGIN_CONFIG.componentThresholds[q].name.toLowerCase().trim() == fileContentToJson.componentThresholds[z].name.toLowerCase().trim()) {
															PLUGIN_CONFIG.componentThresholds[q].uid = component.id;
															PLUGIN_CONFIG.componentThresholds[q].threshold = fileContentToJson.componentThresholds[z].threshold;
															found = true;
															break;
														}
													}
													if(!found) {
														fileContentToJson.componentThresholds[z].uid = component.id;
														PLUGIN_CONFIG.componentThresholds.push(fileContentToJson.componentThresholds[z]);
													}
												}													
											}									
										}										
									}
								}
							}
							savePluginConfig();
							
							//clear input
							$('input[type="file"]').val(null);
							
							var $status = $("#import-status");
							$status.text("import ok");
							$status.css('color', 'black');
							$("#import-status").show();
							
							$("#thresholds").empty();
							//get configured components thresholds
							if (PLUGIN_CONFIG.componentThresholds != null && PLUGIN_CONFIG.componentThresholds.length > 0) {
								for (var i = 0; i < PLUGIN_CONFIG.componentThresholds.length; ++i) {
				
									var $li = $("<li></li>");
									var $category = $("<span></span>");
									var $description = $("<span></span>");
									var $input = $("<input type='text' value='"+PLUGIN_CONFIG.componentThresholds[i].threshold+"' onkeypress='bigh.onlyPosFloat();'></input>");
									var $remove = $("<span>&nbsp;</span>");
				
				
									$category.text(PLUGIN_CONFIG.componentThresholds[i].category);
									$category.addClass("category");
									$description.text(PLUGIN_CONFIG.componentThresholds[i].name);
									$description.addClass("name");
									$input.addClass("inputThreshold");
									$remove.addClass("removeThreshold").addClass("ui-icon").addClass("ui-icon-circle-close");
				
									$li.attr("title", PLUGIN_CONFIG.componentThresholds[i].name);
									$li.attr("component-id", PLUGIN_CONFIG.componentThresholds[i].uid);
				
									$li.append($category).append($description).append($input).append($remove);
									$("#thresholds").append($li);
													
								}
							}
						},
					});	
				
				} catch (error) {
					var $status = $("#import-status");
					$status.text("import error");
					$status.css('color', 'red');
					$("#import-status").show();
				}						
			};
		})(file);

		// Read in the file as text.
		reader.readAsText(file);
	}
	
	function savePluginConfig() { 
		
		if(PLUGIN_CONFIG !== undefined && PLUGIN_CONFIG != null) {
			$.ajax({
		    	url: URL_OUT,
		    	type: "post",
		    	data: {config : JSON.stringify(PLUGIN_CONFIG) , comp : 'Recorder_Base'},
		    	dataType: "text",
		    	success: function(json){
					saveDone = true;
		            },	
		        error: function(json){
					saveDone = false;
		        }
			});	
		}
		return saveDone;
	}

});
