﻿var Svg = importNamespace('Svg');
var Color = importNamespace('System.Drawing.Color');
var status_param_uid = getEMParam("status_param");
var status_comp = getEMParamByPluginUID("inim", status_param_uid);

var svg_fault = svg.GetElementById("fault");
var svg_ready = svg.GetElementById("ready");
var svg_alarm = svg.GetElementById("alarm");
var svg_short = svg.GetElementById("short");
var svg_bypass = svg.GetElementById("bypass");
var svg_memory = svg.GetElementById("memory");

svg_fault.Visibility = "Hidden";
svg_ready.Visibility = "Hidden";
svg_alarm.Visibility = "Hidden";
svg_short.Visibility = "Hidden";
svg_bypass.Visibility = "Hidden";
svg_memory.Visibility = "Hidden";
UpdateWidget();



function status_changed() {

    var val = getValueAsInt(status_comp);
    log("Status changed to:" + val);

    svg_fault.Visibility = "Hidden";
    svg_ready.Visibility = "Hidden";
    svg_alarm.Visibility = "Hidden";
    svg_short.Visibility = "Hidden";
    svg_bypass.Visibility = "Hidden";
    svg_memory.Visibility = "Hidden";

    if (val == 0) svg_fault.Visibility = "Visible";
    if (val == 1) svg_ready.Visibility = "Visible";
    if (val == 2) svg_alarm.Visibility = "Visible";
    if (val == 3) svg_short.Visibility = "Visible";
    if (val == 4) svg_bypass.Visibility = "Visible";
    if (val == 5) svg_memory.Visibility = "Visible";



    UpdateWidget();
}




setTrigger(status_comp, "status_changed");
